Set Warnings "-notation-overridden,-parsing".
Require Import Combo.
Parameter MISSING: Type.   

Module Check.  

Ltac check_type A B :=  
match type of A with  
| context[MISSING] => idtac "Missing:" A  
| ?T => first [unify T B; idtac "Type: ok" | idtac "Type: wrong - should be (" B ")"]  
end.  

Ltac print_manual_grade A :=  
first [  
match eval compute in A with  
| ?T => idtac "Score:" T  
end  
| idtac "Score: Ungraded"].  

End Check.

Require Import Combo.
Import Check.

Goal True.

idtac "-------------------  product_exercises  --------------------".
idtac " ".

idtac "#> Manually graded: product_exercises".
idtac "Possible points: 1".
print_manual_grade score_product_exercises.
idtac " ".

idtac "-------------------  tlas_more  --------------------".
idtac " ".

idtac "#> Manually graded: tlas_more".
idtac "Possible points: 2".
print_manual_grade score_tlas_more.
idtac " ".

idtac "-------------------  product_times  --------------------".
idtac " ".

idtac "#> product_times".
idtac "Possible points: 2".
check_type @product_times (
(forall (X Y : Type) (l1 : list X) (l2 : list Y),
 @length (X * Y) (@product X Y l1 l2) = @length X l1 * @length Y l2)).
idtac "Assumptions:".
Abort.
Print Assumptions product_times.
Goal True.
idtac " ".

idtac "-------------------  lists_of_bools  --------------------".
idtac " ".

idtac "#> Manually graded: lists_of_bools".
idtac "Possible points: 3".
print_manual_grade score_lists_of_bools.
idtac " ".

idtac "-------------------  perms_two_of_six  --------------------".
idtac " ".

idtac "#> Manually graded: perms_two_of_six".
idtac "Possible points: 2".
print_manual_grade score_perms_two_of_six.
idtac " ".

idtac "-------------------  factorial_nz  --------------------".
idtac " ".

idtac "#> factorial_nz".
idtac "Possible points: 1".
check_type @factorial_nz ((forall n : nat, factorial n <> 0)).
idtac "Assumptions:".
Abort.
Print Assumptions factorial_nz.
Goal True.
idtac " ".

idtac "-------------------  perms_six  --------------------".
idtac " ".

idtac "#> Manually graded: perms_six".
idtac "Possible points: 1".
print_manual_grade score_perms_six.
idtac " ".

idtac "-------------------  permutations_complete  --------------------".
idtac " ".

idtac "#> permutations_complete".
idtac "Possible points: 2".
check_type @permutations_complete (
(forall (A : Type) (l l' : list A),
 @In (list A) l' (@permutations A l) -> @Permutation A l l')).
idtac "Assumptions:".
Abort.
Print Assumptions permutations_complete.
Goal True.
idtac " ".

idtac "-------------------  permutation_length  --------------------".
idtac " ".

idtac "#> permutation_length".
idtac "Possible points: 3".
check_type @permutation_length (
(forall (A : Type) (l l' : list A) (a : A),
 @In (list A) l' (@permutations A l) ->
 @length (list A) (@everywhere A a l') = S (@length A l))).
idtac "Assumptions:".
Abort.
Print Assumptions permutation_length.
Goal True.
idtac " ".

idtac "-------------------  permutations_length  --------------------".
idtac " ".

idtac "#> permutations_length".
idtac "Possible points: 2".
check_type @permutations_length (
(forall (A : Type) (l : list A) (n : nat),
 @length A l = n -> @length (list A) (@permutations A l) = factorial n)).
idtac "Assumptions:".
Abort.
Print Assumptions permutations_length.
Goal True.
idtac " ".

idtac "-------------------  choose_two_of_six  --------------------".
idtac " ".

idtac "#> Manually graded: choose_two_of_six".
idtac "Possible points: 2".
print_manual_grade score_choose_two_of_six.
idtac " ".

idtac "-------------------  taco_tuesday  --------------------".
idtac " ".

idtac "#> Manually graded: taco_tuesday".
idtac "Possible points: 2".
print_manual_grade score_taco_tuesday.
idtac " ".

idtac "-------------------  choose_fact_informal  --------------------".
idtac " ".

idtac "#> Manually graded: choose_fact_informal".
idtac "Possible points: 4".
print_manual_grade score_choose_fact_informal.
idtac " ".

idtac "-------------------  mult_nz  --------------------".
idtac " ".

idtac "#> mult_nz".
idtac "Possible points: 3".
check_type @mult_nz ((forall m n nz : nat, m * nz = n * nz -> nz <> 0 -> m = n)).
idtac "Assumptions:".
Abort.
Print Assumptions mult_nz.
Goal True.
idtac " ".

idtac "-------------------  choose_swap  --------------------".
idtac " ".

idtac "#> choose_swap".
idtac "Possible points: 2".
check_type @choose_swap ((forall m n : nat, choose (n + m) m = choose (n + m) n)).
idtac "Assumptions:".
Abort.
Print Assumptions choose_swap.
Goal True.
idtac " ".

idtac "-------------------  binomial_theorem  --------------------".
idtac " ".

idtac "#> Manually graded: binomial_theorem".
idtac "Possible points: 4".
print_manual_grade score_binomial_theorem.
idtac " ".

idtac "-------------------  binomial_consequences  --------------------".
idtac " ".

idtac "#> binomial_x_plus_1".
idtac "Possible points: 1".
check_type @binomial_x_plus_1 (
(forall x n : nat,
 exp (x + 1) n = sum_nm n 0 (fun k : nat => choose n k * exp x (n - k)))).
idtac "Assumptions:".
Abort.
Print Assumptions binomial_x_plus_1.
Goal True.
idtac " ".

idtac "#> binomial_three_to_the_n".
idtac "Possible points: 1".
check_type @binomial_three_to_the_n (
(forall n : nat,
 exp 3 n = sum_nm n 0 (fun k : nat => choose n k * exp 2 (n - k)))).
idtac "Assumptions:".
Abort.
Print Assumptions binomial_three_to_the_n.
Goal True.
idtac " ".

idtac " ".

idtac "Max points - standard: 38".
idtac "Max points - advanced: 38".
Abort.
