Set Warnings "-notation-overridden,-parsing".
Require Import Sort.
Parameter MISSING: Type.   

Module Check.  

Ltac check_type A B :=  
match type of A with  
| context[MISSING] => idtac "Missing:" A  
| ?T => first [unify T B; idtac "Type: ok" | idtac "Type: wrong - should be (" B ")"]  
end.  

Ltac print_manual_grade A :=  
first [  
match eval compute in A with  
| ?T => idtac "Score:" T  
end  
| idtac "Score: Ungraded"].  

End Check.

Require Import Sort.
Import Check.

Goal True.

idtac "-------------------  Permutation_properties  --------------------".
idtac " ".

idtac "#> Manually graded: Permutation_properties".
idtac "Possible points: 2".
print_manual_grade score_Permutation_properties.
idtac " ".

idtac "-------------------  Permutation_refl  --------------------".
idtac " ".

idtac "#> Permutation_refl".
idtac "Possible points: 1".
check_type @Permutation_refl ((forall (A : Type) (l : list A), @Permutation A l l)).
idtac "Assumptions:".
Abort.
Print Assumptions Permutation_refl.
Goal True.
idtac " ".

idtac "-------------------  Permutation_length  --------------------".
idtac " ".

idtac "#> Permutation_length".
idtac "Possible points: 1".
check_type @Permutation_length (
(forall (A : Type) (l1 l2 : list A),
 @Permutation A l1 l2 -> @length A l1 = @length A l2)).
idtac "Assumptions:".
Abort.
Print Assumptions Permutation_length.
Goal True.
idtac " ".

idtac "-------------------  Permutation_sym  --------------------".
idtac " ".

idtac "#> Permutation_sym".
idtac "Possible points: 1".
check_type @Permutation_sym (
(forall (A : Type) (l1 l2 : list A),
 @Permutation A l1 l2 -> @Permutation A l2 l1)).
idtac "Assumptions:".
Abort.
Print Assumptions Permutation_sym.
Goal True.
idtac " ".

idtac "-------------------  Permutation_sym_informal  --------------------".
idtac " ".

idtac "#> Manually graded: Permutation_sym_informal".
idtac "Possible points: 2".
print_manual_grade score_Permutation_sym_informal.
idtac " ".

idtac "-------------------  Forall_perm  --------------------".
idtac " ".

idtac "#> Forall_perm".
idtac "Possible points: 2".
check_type @Forall_perm (
(forall (A : Type) (f : A -> Prop) (al bl : list A),
 @Permutation A al bl -> @Forall A f al -> @Forall A f bl)).
idtac "Assumptions:".
Abort.
Print Assumptions Forall_perm.
Goal True.
idtac " ".

idtac "-------------------  insert_perm  --------------------".
idtac " ".

idtac "#> insert_perm".
idtac "Possible points: 3".
check_type @insert_perm (
(forall (x : nat) (l : list nat), @Permutation nat (x :: l) (insert x l))).
idtac "Assumptions:".
Abort.
Print Assumptions insert_perm.
Goal True.
idtac " ".

idtac "-------------------  sort_perm  --------------------".
idtac " ".

idtac "#> sort_perm".
idtac "Possible points: 3".
check_type @sort_perm ((forall l : list nat, @Permutation nat l (sort l))).
idtac "Assumptions:".
Abort.
Print Assumptions sort_perm.
Goal True.
idtac " ".

idtac "-------------------  insert_sorted  --------------------".
idtac " ".

idtac "#> insert_sorted".
idtac "Possible points: 4".
check_type @insert_sorted (
(forall (a : nat) (l : list nat), sorted l -> sorted (insert a l))).
idtac "Assumptions:".
Abort.
Print Assumptions insert_sorted.
Goal True.
idtac " ".

idtac "-------------------  sort_sorted  --------------------".
idtac " ".

idtac "#> sort_sorted".
idtac "Possible points: 2".
check_type @sort_sorted ((forall l : list nat, sorted (sort l))).
idtac "Assumptions:".
Abort.
Print Assumptions sort_sorted.
Goal True.
idtac " ".

idtac "-------------------  sort_idempotent_informal  --------------------".
idtac " ".

idtac "#> Manually graded: sort_idempotent_informal".
idtac "Possible points: 3".
print_manual_grade score_sort_idempotent_informal.
idtac " ".

idtac "-------------------  sorted_sorted'  --------------------".
idtac " ".

idtac "#> sorted_sorted'".
idtac "Possible points: 4".
check_type @sorted_sorted' ((forall al : list nat, sorted al -> sorted' al)).
idtac "Assumptions:".
Abort.
Print Assumptions sorted_sorted'.
Goal True.
idtac " ".

idtac "-------------------  sorted'_sorted  --------------------".
idtac " ".

idtac "#> sorted'_sorted".
idtac "Possible points: 3".
check_type @sorted'_sorted ((forall al : list nat, sorted' al -> sorted al)).
idtac "Assumptions:".
Abort.
Print Assumptions sorted'_sorted.
Goal True.
idtac " ".

idtac "-------------------  Forall_nth  --------------------".
idtac " ".

idtac "#> Forall_nth".
idtac "Possible points: 3".
check_type @Forall_nth (
(forall (A : Type) (P : A -> Prop) (d : A) (al : list A),
 @Forall A P al <-> (forall i : nat, i < @length A al -> P (@nth A i al d)))).
idtac "Assumptions:".
Abort.
Print Assumptions Forall_nth.
Goal True.
idtac " ".

idtac " ".

idtac "Max points - standard: 34".
idtac "Max points - advanced: 34".
Abort.
